<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ProCart 3.8                                       ***
  ***      File:  admin_user.php                                           ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.softinteractive.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/parameters.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/download_messages.php");

	check_admin_security("site_users");
	$permissions = get_permissions();
	$add_users = get_setting_value($permissions, "add_users", 0);
	$update_users = get_setting_value($permissions, "update_users", 0);
	$remove_users = get_setting_value($permissions, "remove_users", 0);

	$type = get_param("type");
	$user_type_id = get_param("user_type_id");
	$user_id = get_param("user_id");
	if (strlen($user_type_id)) {
		$type_id = $user_type_id;
	} else if (strlen($user_id)) {
		$sql  = " SELECT user_type_id FROM " . $table_prefix . "users ";
		$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$type_id = get_db_value($sql);
	} else {
		$type_id = $type;
	}
	$setting_type = "user_profile_" . $type_id;
	$html_editor = get_setting_value($settings, "html_editor", 1);
	$site_url = get_setting_value($settings, "site_url", "");

	$user_settings = array();
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "user_types_settings WHERE type_id=" . $db->tosql($type_id, INTEGER);
	$db->query($sql);
	while($db->next_record()) {
		$user_settings[$db->f("setting_name")] = $db->f("setting_value");
	}
	$affiliate_join = get_setting_value($user_settings, "affiliate_join", 0);

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_user.html");
	$t->set_var("css_file", "../styles/" . $settings["style_name"] . ".css");
	$t->set_var("html_editor", $html_editor);
	$t->set_var("site_url", $site_url);

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_users_href", "admin_users.php");
	$t->set_var("admin_user_href", "admin_user.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("admin_upload_href", "admin_upload.php");

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
	$db->query($sql);
	while($db->next_record()) {
		$user_profile[$db->f("setting_name")] = $db->f("setting_value");
	}
	$r = new VA_Record($table_prefix . "users");
	$r->return_page = "admin_users.php";

	$r->add_where("user_id", INTEGER);

	$approved_values = array(array("1", YES_MSG), array("0", NO_MSG));
	$r->add_radio("is_approved", INTEGER, $approved_values, "Approved");
	$r->change_property("is_approved", DEFAULT_VALUE, 1);

	$user_types = get_db_values("SELECT type_id,type_name FROM " . $table_prefix . "user_types ", "");
	$r->add_select("user_type_id", TEXT, $user_types, "User Type");
	$r->change_property("user_type_id", DEFAULT_VALUE, $type_id);

	$r->add_textbox("friendly_url", TEXT, FRIENDLY_URL_MSG);
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url");

	$r->add_textbox("affiliate_code", TEXT, AFFILIATE_CODE_FIELD);
	$r->change_property("affiliate_code", USE_SQL_NULL, false);
	if ($affiliate_join) {
		$r->change_property("affiliate_code", REQUIRED, true);
	}


	$discount_types = array( 
		array("", ""), array(0, "Not available"), array(1, "Percentage per product/option selling price"), 
		array(2, "Amount per product"), array(3, "Percentage per product selling price"),
		array(4, "Percentage per (selling price - buying price)")
	);
	$r->add_select("discount_type", INTEGER, $discount_types);
	$r->add_textbox("discount_amount", NUMBER, "Discount Amount");

	



	if(!$user_id)
	{
		$r->add_textbox("login", TEXT, "Login");
		$r->parameters["login"][REQUIRED] = true;
		$r->parameters["login"][UNIQUE] = true;
		$r->parameters["login"][MIN_LENGTH] = 3;
		$r->add_textbox("password", TEXT, PASSWORD_FIELD);
		$r->parameters["password"][REQUIRED] = true;
		$r->parameters["password"][MIN_LENGTH] = 3;
		$r->add_textbox("confirm", TEXT, CONFIRM_PASS_FIELD);
		$r->change_property("confirm", USE_IN_SELECT, false);
		$r->change_property("confirm", USE_IN_INSERT, false);
		$r->change_property("confirm", USE_IN_UPDATE, false);
		$r->change_property("password", MATCHED, "confirm");
	}

	$companies = get_db_values("SELECT company_id,company_name FROM " . $table_prefix . "companies ", array(array("", SELECT_COMPANY_MSG)));
	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states", array(array("", SELECT_STATE_MSG)));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order ", array(array("", SELECT_COUNTRY_MSG)));

	$r->add_textbox("name", TEXT, NAME_FIELD);
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, FIRST_NAME_FIELD);
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, LAST_NAME_FIELD);
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_select("company_id", INTEGER, $companies, COMPANY_SELECT_FIELD);
	$r->add_textbox("company_name", TEXT, COMPANY_NAME_FIELD);
	$r->add_textbox("email", TEXT, EMAIL_FIELD);
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->change_property("email", UNIQUE, true);
	$r->add_textbox("address1", TEXT, STREET_FIRST_FIELD);
	$r->add_textbox("address2", TEXT, STREET_SECOND_FIELD);
	$r->add_textbox("city", TEXT, CITY_FIELD);
	$r->add_textbox("province", TEXT, PROVINCE_FIELD);
	$r->add_select("state_code", TEXT, $states, STATE_FIELD);
	$r->add_textbox("zip", TEXT, ZIP_FIELD);
	$r->add_select("country_code", TEXT, $countries, COUNTRY_FIELD);
	$r->add_textbox("phone", TEXT, "Phone");
	$r->add_textbox("daytime_phone", TEXT, DAYTIME_PHONE_FIELD);
	$r->add_textbox("evening_phone", TEXT, EVENING_PHONE_FIELD);
	$r->add_textbox("cell_phone", TEXT, CELL_PHONE_FIELD);
	$r->add_textbox("fax", TEXT, FAX_FIELD);
	$r->add_textbox("personal_image", TEXT, PERSONAL_IMAGE_FIELD);
	if(!isset($user_profile["show_personal_image"]) || $user_profile["show_personal_image"] != 1) {
		$r->parameters["personal_image"][SHOW] = false;
	}

	$r->add_textbox("delivery_name", TEXT, DELIVERY_MSG." ".NAME_FIELD);
	$r->add_textbox("delivery_first_name", TEXT, DELIVERY_MSG." ".FIRST_NAME_FIELD);
	$r->add_textbox("delivery_last_name", TEXT, DELIVERY_MSG." ".LAST_NAME_FIELD);
	$r->add_select("delivery_company_id", INTEGER, $companies, DELIVERY_MSG." ".COMPANY_SELECT_FIELD);
	$r->add_textbox("delivery_company_name", TEXT, DELIVERY_MSG." ".COMPANY_NAME_FIELD);
	$r->add_textbox("delivery_email", TEXT, DELIVERY_MSG." ".EMAIL_FIELD);
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, DELIVERY_MSG." ".STREET_FIRST_FIELD);
	$r->add_textbox("delivery_address2", TEXT, DELIVERY_MSG." ".STREET_SECOND_FIELD);
	$r->add_textbox("delivery_city", TEXT, DELIVERY_MSG." ".CITY_FIELD);
	$r->add_textbox("delivery_province", TEXT, DELIVERY_MSG." ".PROVINCE_FIELD);
	$r->add_select("delivery_state_code", TEXT, $states, DELIVERY_MSG." ".STATE_FIELD);
	$r->add_textbox("delivery_zip", TEXT, DELIVERY_MSG." ".ZIP_FIELD);
	$r->add_select("delivery_country_code", TEXT, $countries, DELIVERY_MSG." ".COUNTRY_FIELD);
	$r->add_textbox("delivery_phone", TEXT, DELIVERY_MSG." ".PHONE_FIELD);
	$r->add_textbox("delivery_daytime_phone", TEXT, DELIVERY_MSG." ".DAYTIME_PHONE_FIELD);
	$r->add_textbox("delivery_evening_phone", TEXT, DELIVERY_MSG." ".EVENING_PHONE_FIELD);
	$r->add_textbox("delivery_cell_phone", TEXT, DELIVERY_MSG." ".CELL_PHONE_FIELD);
	$r->add_textbox("delivery_fax", TEXT, DELIVERY_MSG." ".FAX_FIELD);

	// additional fields
	$r->add_textbox("paypal_account", TEXT, PAYPAL_ACCOUNT_FIELD);
	$r->add_textbox("tax_id", TEXT, TAX_ID_FIELD);
	$r->add_textbox("short_description", TEXT, SHORT_DESCRIPTION_MSG);
	$r->add_textbox("full_description", TEXT, FULL_DESCRIPTION_MSG);

	$r->add_textbox("registration_date", DATETIME);
	$r->change_property("registration_date", USE_IN_SELECT, false);
	$r->change_property("registration_date", USE_IN_UPDATE, false);
	$r->add_textbox("modified_date", DATETIME);
	$r->change_property("modified_date", USE_IN_SELECT, false);

	$r->events[BEFORE_INSERT] = "encrypt_user_password";
	$r->events[AFTER_REQUEST] = "set_user_fields";

	$r->operations[INSERT_ALLOWED] = $add_users;
	$r->operations[UPDATE_ALLOWED] = $update_users;
	$r->operations[DELETE_ALLOWED] = $remove_users;

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$personal_param = "show_" . $parameters[$i];
		$delivery_param = "show_delivery_" . $parameters[$i];
		if(isset($user_profile[$personal_param]) && $user_profile[$personal_param] == 1) {
			$personal_number++;
			if($user_profile[$parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if(isset($user_profile[$delivery_param]) && $user_profile[$delivery_param] == 1) {
			$delivery_number++;
			if($user_profile["delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$additional_number = 0;
	for($i = 0; $i < sizeof($additional_parameters); $i++)
	{                                    
		$param_name = "show_" . $additional_parameters[$i];
		$param_required = $additional_parameters[$i] . "_required";
		if(isset($user_profile[$param_name]) && $user_profile[$param_name] == 1) {
			$additional_number++;
			if($user_profile[$param_required] == 1) {
				$r->parameters[$additional_parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$additional_parameters[$i]][SHOW] = false;
		}
	}

	$r->add_checkbox("same_as_personal", INTEGER);
	$r->change_property("same_as_personal", USE_IN_SELECT, false);
	$r->change_property("same_as_personal", USE_IN_INSERT, false);
	$r->change_property("same_as_personal", USE_IN_UPDATE, false);
	if($personal_number < 1 || $delivery_number < 1) {
		$r->parameters["same_as_personal"][SHOW] = false;
	}

	$operation = get_param("operation");
	$user_id = get_param("user_id");

	//$r->events[BEFORE_INSERT] = "set_friendly_url";
	//$r->events[BEFORE_UPDATE] = "set_friendly_url";

	$r->process();

	$affiliate_code = $r->get_value("affiliate_code");
	if (!strlen($affiliate_code)) {
		$affiliate_code = "type_your_code_here";
	}
	$affiliate_url = $site_url . "?af=" . $affiliate_code;
	$affiliate_code_help = str_replace("{affiliate_url}", $affiliate_url, AFFILIATE_CODE_HELP_MSG);
	$t->set_var("affiliate_code_help", $affiliate_code_help);

	$r->set_form_parameters();
	$t->set_var("type", htmlspecialchars($type));

	if ($personal_number > 0) {
		$t->sparse("personal", false);
	}

	if ($delivery_number > 0) {
		$t->sparse("delivery", false);
	}

	if ($additional_number > 0) {
		$t->sparse("additional", false);
	}

	if(!strlen($user_id))	{
		$t->parse("login_information", false);
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

	function encrypt_user_password()
	{
		global $r, $settings;
		$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
		if ($password_encrypt == 1) {
			$r->set_value("password", md5($r->get_value("password")));
		}
	}

	function set_user_fields()
	{
		global $r, $parameters, $user_profile;

		$current_date = va_time();
		$r->set_value("registration_date", $current_date);
		$r->set_value("modified_date", $current_date);

		if($r->get_value("same_as_personal")) {
			for($i = 0; $i < sizeof($parameters); $i++) { 
				$personal_param = "show_" . $parameters[$i];
				$delivery_param = "show_delivery_" . $parameters[$i];
				if(isset($user_profile[$delivery_param]) && isset($user_profile[$personal_param]) &&
					$user_profile[$delivery_param] == 1 && $user_profile[$personal_param] == 1) {
					$r->set_value("delivery_" . $parameters[$i], $r->get_value($parameters[$i]));
				}
			}
		}

	}

?>