<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_articles_top_rated.php                             ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function articles_top_rated($block_name, $top_id, $top_name)
{

	global $t, $db, $table_prefix;
	global $settings, $page_settings;
	global $category_id;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	if (!strlen($top_name)) {
		$sql  = " SELECT category_name FROM " . $table_prefix . "articles_categories ";
		$sql .= " WHERE category_id=" . $db->tosql($top_id, INTEGER);
		$db->query($sql);
		if ($db->next_record()) {
			$top_name = get_translation($db->f("category_name"));
		}
	}

	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");

	$t->set_file("block_body", "block_top_rated.html");
	$t->set_var("top_category_name",$top_name);
	$t->set_var("TOP_RATED_TITLE",  TOP_RATED_TITLE);
	$t->set_var("top_rated_items",  "");

	$sql  = " SELECT a.article_id, a.article_title, a.friendly_url, a.rating ";
	$sql .= " FROM " . $table_prefix . "articles a ";
	$sql .= " , " . $table_prefix . "articles_statuses st ";
	$sql .= " , " . $table_prefix . "articles_assigned aa ";
	$sql .= " , " . $table_prefix . "articles_categories ac ";
	$sql .= " WHERE a.status_id=st.status_id AND a.article_id=aa.article_id AND aa.category_id=ac.category_id ";
	$sql .= " AND (ac.category_id=" . $db->tosql($top_id, INTEGER);
	$sql .= " OR ac.category_path LIKE '0," . $top_id . ",%') ";
	$sql .= " AND st.allowed_view=1 ";
	$sql .= " AND a.total_votes>=" . $db->tosql(get_setting_value($settings, "min_votes", 10), INTEGER);
	$sql .= " AND a.rating>=" . $db->tosql(get_setting_value($settings, "min_rating", 1), FLOAT);
	$sql .= " GROUP BY a.article_id, a.article_order, a.article_title, a.friendly_url, a.total_points, a.rating ";
	$sql .= " ORDER BY a.rating DESC, a.article_order, a.article_title ";

	$db->RecordsPerPage = 10;
	$db->PageNumber = 1;
	$db->query($sql);
	if($db->next_record())
	{
		$item_number = 0;
		do
		{
			$item_number++;
			$article_id = $db->f("article_id");
			$friendly_url = $db->f("friendly_url");
			$top_rating = $db->f("rating");
			if ($friendly_urls && $friendly_url) {
				$t->set_var("details_href", $friendly_url . $friendly_extension);
			} else {
				$t->set_var("details_href", "article.php?article_id=" . $article_id);
			}

			$t->set_var("top_position", $item_number);
			$t->set_var("top_name", get_translation($db->f("article_title")));
			$t->set_var("top_rating", number_format($top_rating, 2));

			$t->parse("top_rated_items", true);
		} while ($db->next_record());              	
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>